#!/usr/bin/perl

#    ADC2000 v3.3 Deluxe - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

read (STDIN,$query,$ENV{CONTENT_LENGTH});
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
unless ($data{email}=~/.+\@.+/)
{
	push (@errors,"Incorrect <b>e-mail</b>, you must put your e-mail address<br>\n");
	open (F,"<$adcpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$destination=$data{method};
&$destination;

sub subscribe
{
open (F,"<$basepath/$data{destination}/maillist");
flock(F,$LOCK_EX);
@emaillist=<F>;
flock(F,$LOCK_UN);
close(F);
foreach(@emaillist)
{
	chop;
	if ($_ eq $data{email})
	{
		push (@errors,"Your <b>e-mail</b> is already exist in our maillist<br>\n");
		open (F,"<$adcpath/template/error.tpl");
		@htmlpage=<F>;
		close (F);
		$htmlpage=join("\n",@htmlpage);
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $htmlpage;
		exit;
	}
}
open (F,">>$basepath/$data{destination}/maillist");
flock(F,$LOCK_EX);
print F "$data{email}\n";
flock(F,$LOCK_UN);
close(F);
open (F,"<$adcpath/template/subscr.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub unsubscribe
{
open (F,"+<$basepath/$data{destination}/maillist");
flock(F,$LOCK_EX);
@emaillist=<F>;
foreach(@emaillist)
{
	chop;
	if ($_ eq $data{email})
	{
		$flag=1;
		next;
	}
	push(@nemaillist,"$_\n");
}
if (!$flag)
{
	flock(F,$LOCK_UN);
	close(F);
	push (@errors,"Your <b>e-mail</b> is not exist in our maillist<br>\n");
	open (F,"<$adcpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("\n",@htmlpage);
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
truncate (F,0);
seek (F,0,0);
print F @nemaillist;
flock(F,$LOCK_UN);
close(F);
open (F,"<$adcpath/template/unsubscr.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}